package com.zhiLian.vehicle.job;


import com.zhiLian.common.redis.service.RedisService;
import com.zhiLian.vehicle.datasource.config.holder.DynamicDataSourceHolder;
import com.zhiLian.vehicle.domain.Vehicle;
import com.zhiLian.vehicle.mapper.VehicleMapper;
import com.zhiLian.vehicle.service.IVehicleService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.concurrent.Executor;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

/**
 * BingRui.Hou
 *
 * @Description 描述
 * @ClassName ManyJob
 * @Date 2024/06/20 17:34
 */
@Component
@Log4j2
public class ManyJob {

    @Autowired
    private RedisTemplate<String,String> redisTemplate;

    @Autowired
    private RedisService redisService;

    @Autowired
    private VehicleMapper vehicleService;

    @Scheduled(cron = "0 0 0 * * ?")// 每10分钟执行一次
    public void manyJob(){
        DynamicDataSourceHolder.setDynamicDataSourceKey("test_00");
        List<Vehicle> list = vehicleService.selectVehicleListAll(new Vehicle());
        ExecutorService executor = Executors.newFixedThreadPool(list.size());
        list.forEach(vehicle -> {
            executor.submit(new Runnable() {
                @Override
                public void run() {
                    redisTemplate
                            .opsForValue()
                            .set(vehicle.getNumber()+"1",
                            String.valueOf(vehicle.getBusinessId()));
                }
            });
        });
        DynamicDataSourceHolder.removeDynamicDataSourceKey();

    }
}
